#include "UrsStringHelper.h"


char UrsStringHelperClass::thousandSeparator[] = ",";
char UrsStringHelperClass::decimalSeparator[] = ".";
char UrsStringHelperClass::hexSeparator[] = " ";


String UrsStringHelperClass::valToStr(uint64_t val) {
   String header;
   header.reserve(30);
   return valToStr(header, val);
}

String UrsStringHelperClass::valToStr(int64_t val, bool plusSign) {
   String header;
   header.reserve(30);
   if (val < 0) { // negative values
      header += "-";
      return valToStr(header, -val);
   }
   // positive values  
   if (plusSign)
      header += "+";

   return valToStr(header, val);
}

void UrsStringHelperClass::strrev(String& string) {
   uint8_t tmp;
   int len = string.length();
   char* str = const_cast<char*>(string.c_str());

   for (int i = 0, j = len - 1; i < j; i++, j--) {
      tmp = str[i];
      str[i] = str[j];
      str[j] = tmp;
   }
}

String UrsStringHelperClass::valToStr(String header, uint64_t val) {
   String digits;
   uint8_t digCnt = 0;
   char buf[] = "0";


   while (val != 0) {
      if (digCnt >= 3) { // add a thousands separator every three digits
         digCnt = 0;
         digits += thousandSeparator;
      }
      buf[0] = (char)(val % 10) + '0';
      digits += buf; // add another digit to the buffer
      digCnt++;

      val /= 10; // prepare for producing the next digit
   }
   strrev(digits);
   if (digits.length() == 0)
      digits = "0";

   return header + digits;
}

String UrsStringHelperClass::valToHex(uint64_t val, uint8_t digits) {
   uint8_t digCnt = 0;
   char buf[] = "0";
   String output;
   output.reserve(20);

   while (digits-- > 0) {
      if (digCnt >= 4) { // add a hex separator every four digits
         digCnt = 0;
         if (hexSeparator[0]) // only if valid
            output += hexSeparator;
      }
      uint8_t c = val & 0x0F;
      buf[0] = c < 10 ? c + '0' : c - 10 + 'A';
      output += buf; // add another digit to the buffer
      digCnt++;

      val >>= 4; // prepare for producing the next digit
   }
   strrev(output);
   return output;
}




UrsStringHelperClass UrsStringHelper;
UrsStringHelperClass& SHelper = UrsStringHelper;